﻿Type=Activity
Version=1.50
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
    
	'TimeValue holds a random day in the month to be displayed
	'On start, this must be set accordingly to which month to be displayed
	'In this demo it is set to DateTime.Now which is todays date
	'and the calendar shows the current month
	Dim TimeValue As Long
	
	Dim FirstDayOfMonth As Long
	Dim LastDayOfMonth As Long 
    Dim Day() As String
    Dim Month() As String
	Dim DaySelected As Long 'Return value to the calling Activity
	Dim FirstDayOfWeek As Int
	
	DaySelected = 0
	
	'Initial texts
	Dim ActivityTitle As String : ActivityTitle = "Select date"
	Dim CancelText As String : CancelText = "Cancel"
	Dim TodayText As String : TodayText = "Today"

End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim Panel1 As Panel
	Dim Label1 As Label
	Dim Label4 As Label
	Dim Label5 As Label
	Dim Label6 As Label
	Dim Label7 As Label
	Dim Label8 As Label
	Dim Label9 As Label
	Dim Label10 As Label
	Dim Label2 As Label
	Dim NextMonth As Button
	Dim PrevMonth As Button
	Dim Cancel As Button
	Dim CurrentMonth As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
 Dim i As Int 
 Dim loc As AHLocale

 loc.Initialize
 
 'Set which day is the first day of the week
 '1 = Sunday
 '2 = Monday
 FirstDayOfWeek = loc.FirstDayOfWeek
 
 Day = loc.ShortWeekDays
 Month = loc.Months

 DaySelected = 0
 TimeValue = DateTime.Now 
 Activity.LoadLayout("Kalender")	
 Activity.Title = ActivityTitle
 Cancel.Text = CancelText
 CurrentMonth.Text = TodayText
 Panel1.Height = 100%y - Panel1.Top - Cancel.Height - 4dip
 Panel1.Left = (100%x - Panel1.Width) / 2
 If FirstDayOfWeek = 2 Then
  Label4.Text = Day(2)
  Label5.Text = Day(3)
  Label6.Text = Day(4)
  Label7.Text = Day(5)
  Label8.Text = Day(6)
  Label9.Text = Day(7)
  Label10.Text = Day(1)
 Else
  Label4.Text = Day(1)
  Label5.Text = Day(2)
  Label6.Text = Day(3)
  Label7.Text = Day(4)
  Label8.Text = Day(5)
  Label9.Text = Day(6)
  Label10.Text = Day(7)
 End If
 label4.Width = -2
 label5.Width = -2
 label6.Width = -2
 label7.Width = -2
 label8.Width = -2
 label9.Width = -2
 label10.Width = -2
 'DoEvents
 i = 10dip 
 Label4.Left = i + 7dip
 i = i + 40dip
 Label5.Left = i + 7dip
 i = i + 40dip
 Label6.Left = i + 7dip
 i = i + 40dip
 Label7.Left = i + 7dip
 i = i + 40dip
 Label8.Left = i + 7dip
 i = i + 40dip
 Label9.Left = i + 7dip
 i = i + 40dip
 Label10.Left = i + 7dip
 'Cancel.Top = Panel1.Top + Panel1.Height + 15dip
 'CurrentMonth.Top = Panel1.Top + Panel1.Height + 15dip
 Cancel.Top = Activity.Height - Cancel.Height - 2dip
 CurrentMonth.Top = Activity.Height - CurrentMonth.Height - 2dip
 Cancel.Left = (100%x / 2) - (Cancel.Width + CurrentMonth.Width + 15dip) / 2 
 CurrentMonth.Left = Cancel.Left + Cancel.Width + 15dip
 CreateCalendar
 
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub CreateCalendar
 Dim i As Int
 Dim OffsetX As Int
 Dim OffsetY As Int
 Dim TempDay As Long 
 Dim StartDate As Long
 Dim EndDate As Long 
 Dim bDay As Long
 Dim Today As Long 

 Today = DateTime.Now 
 DateTime.DateFormat="ddMMyyyy"
 'Calculate the first day of the month according
 FirstDayOfMonth = DateTime.DateParse("01" & DateTime.Date(TimeValue).SubString(2))
 'Calculate the last day of the month
 TempDay = DateTime.Add(TimeValue,0,1,0)
 TempDay = DateTime.DateParse("01" & DateTime.Date(TempDay).SubString(2))
 LastDayOfMonth = DateTime.Add(TempDay,0,0,-1)
 
 
 Label1.Text = Month(DateTime.GetMonth(TimeValue) - 1) & "  " & DateTime.GetYear(TimeValue)
 OffsetX = 10dip
 OffsetY = 70dip
 
 'Calculate the first day to be displayed in the calendar
 If FirstDayOfWeek = 2 Then
  If (DateTime.GetDayOfWeek(FirstDayOfMonth) - 1) = 0 Then
   StartDate = DateTime.Add(FirstDayOfMonth,0,0,-6)
  Else
   StartDate = DateTime.Add(FirstDayOfMonth,0,0, 0-(DateTime.GetDayOfWeek(FirstDayOfMonth) - 2))
  End If
 Else
  StartDate = DateTime.Add(FirstDayOfMonth,0,0, 0-(DateTime.GetDayOfWeek(FirstDayOfMonth) - 1))
 End If
 
 bDay = StartDate
 
 'Calculate the last day to be displayed in the calendar
 If FirstDayOfWeek = 2 Then
  If (DateTime.GetDayOfWeek(LastDayOfMonth) - 1) = 0 Then
   EndDate = LastDayOfMonth
  Else
   EndDate = DateTime.Add(LastDayOfMonth,0,0, 8 - DateTime.GetDayOfWeek(LastDayOfMonth))
  End If  
 Else
  EndDate = DateTime.Add(LastDayOfMonth,0,0, 7 - DateTime.GetDayOfWeek(LastDayOfMonth))
 End If
 
 'Place a button for each day to be displayed.
 'Days in the previous and next month are grayed out and cannot be selected
 'Todays date is shown with a red bold text
 'Each buttons tag holds the day of the button
 For i = 1 To 42
  If bDay <= EndDate Then
   Dim bn As Button 
   bn.Initialize("ButtonPress")
   bn.Text = DateTime.GetDayOfMonth(bDay)
   If DateTime.GetMonth(bDay) <> DateTime.GetMonth(TimeValue) Then
	bn.Enabled = False
	bn.Tag = 0
   Else
	bn.Enabled = True
	bn.Tag = bDay
   End If
   If DateTime.Date(bDay) = DateTime.Date(Today)  Then
    bn.TextColor = Colors.Red 
	bn.Typeface = Typeface.DEFAULT_BOLD 
   End If
   'All buttons are placed on a panel
   Panel1.AddView(bn, OffsetX, OffsetY, 40dip, 40dip)
   OffsetX = OffsetX + 40dip
   If OffsetX > (250dip) Then
    OffsetX = 10dip
    OffsetY = OffsetY + 40dip
   End If
   bDay = DateTime.Add(bDay,0,0,1)
  End If
 Next

End Sub

Sub RemovePanelViews
 Dim i As Int
 Dim v As View 
 Dim ii As Long 
 
  For i=Panel1.NumberOfViews-1 To 0 Step -1
  v = Panel1.GetView(i)
  Try
  ii = v.Tag
  If ii >= 0 Then
   Panel1.RemoveViewAt(i)
  End If
  Catch
  End Try
 Next
End Sub

Sub ButtonPress_Click
 'Update DaySelected with the selected day and return to the calling activity
 Dim b As Button 
 b = Sender
 DaySelected = b.Tag 
 Activity.Finish 
 StartActivity(Main)		
End Sub

Sub PrevMonth_Click
 'Show previous month
 RemovePanelViews	
 TimeValue = DateTime.Add(FirstDayOfMonth,0,-1,0)
 CreateCalendar	
End Sub

Sub NextMonth_Click
 'Show next month
 RemovePanelViews 	
 TimeValue = DateTime.Add(FirstDayOfMonth,0,1,0)
 CreateCalendar	
End Sub
Sub CurrentMonth_Click
 'Show current month
 RemovePanelViews	
 TimeValue = DateTime.Now 	
 CreateCalendar	
End Sub
Sub Cancel_Click
 'Return to calling activity without selecting a day
 Activity.Finish 
 StartActivity(Main)			
End Sub